<template>
  <b-container class="mb-3 p-0 w-100 coscine-form-container">
    <b-form-group
      class="w-100 m-0"
      :class="mandatory === true ? 'mandatory' : ''"
      :label-class="labelClass"
      :label-for="labelFor"
      :label-cols-sm="labelColsSm"
      :label-align-sm="labelAlignSm"
    >
      <!-- Loading Skeleton -->
      <b-placeholder-wrapper :loading="isLoading">
        <template #loading>
          <b-placeholder
            :type="type"
            size="lg"
            animation="wave"
          ></b-placeholder>
        </template>

        <div>
          <slot />
        </div>
      </b-placeholder-wrapper>

      <!-- Label Template -->
      <template #label>
        <!-- Label -->
        <span id="label" class="text-break">{{ label }}</span>

        <div v-if="info" class="d-inline-flex ms-1">
          <!-- Information Circle Icon -->
          <i-bi-info-circle :id="`${labelFor}Info`" />

          <!-- Popover -->
          <b-popover
            over
            :target="`${labelFor}Info`"
            triggers="hover focus"
            placement="bottom"
          >
            <!-- Popover Contents -->
            <slot name="popover" />
          </b-popover>
        </div>
      </template>
    </b-form-group>
    <b-row no-gutters>
      <b-col :sm="labelColsSm as ColsNumbers" />
      <!-- Hint Text -->
      <b-col id="hint" class="small text-muted ps-2" align-self="end">
        <slot name="hint" />
      </b-col>
    </b-row>
  </b-container>
</template>

<script lang="ts">
import type { ColsNumbers } from "bootstrap-vue-next/dist/src/types";
import type { TranslateResult } from "vue-i18n";

export default defineComponent({
  name: "CoscineFormGroup",
  props: {
    info: {
      default: false,
      type: Boolean,
    },
    isLoading: {
      default: false,
      type: Boolean,
    },
    mandatory: {
      default: false,
      type: Boolean,
    },
    labelClass: {
      default: null,
      type: String,
    },
    labelFor: {
      default: null,
      type: String,
    },
    label: {
      default: null,
      type: [String, Object] as PropType<string | TranslateResult>,
    },
    type: {
      default: "input",
      type: String,
    },
    labelColsSm: {
      default: "3",
      type: String as PropType<ColsNumbers | "0" | "auto">,
    },
    labelAlignSm: {
      default: "right",
      type: String,
    },
  },
});
</script>

<style scoped>
.mandatory :deep(.col-form-label:after) {
  content: " *";
  color: var(--bs-form-invalid-color);
}
#hint {
  position: relative;
}
.row :deep(.col) {
  /* Removes the right padding from the inner col, making it go until the end */
  padding: 0 0 0 5px;
}
.coscine-form-container :deep(.invalid-tooltip) {
  top: auto;
}
</style>

<style>
.text-sm-right {
  text-align: right !important;
}
</style>
